merge 'after squeeze release'-stuff
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
158fda31
DK
82dpkg() {
83 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
84}
b6b5a542
DK
85aptitude() {
86 if [ -f ./aptconfig.conf ]; then
87 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 elif [ -f ../aptconfig.conf ]; then
89 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
90 else
91 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
92 fi
93}
8d876415 94
b720d0bd
DK
95addtrap() {
96 CURRENTTRAP="$CURRENTTRAP $1"
97 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
98}
8d876415
DK
99
100setupenvironment() {
75954ae2 101 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 102 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 103 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 104 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
105 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
106 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 107 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 108 cd $TMPWORKINGDIRECTORY
cd725954 109 mkdir rootdir aptarchive keys
8d876415 110 cd rootdir
b29c3712
DK
111 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
112 mkdir -p var/cache var/lib var/log
cffea9af 113 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 114 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
115 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
116 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
117 else
118 touch var/lib/dpkg/status
119 fi
cd725954 120 touch var/lib/dpkg/available
8d876415
DK
121 mkdir -p usr/lib/apt
122 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
123 cd ..
2c6baa5a 124 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
125 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
126 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 127 fi
4a4ea26c
AM
128 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
129 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
130 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 131 fi
cd725954
DK
132 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
133 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 134 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 135 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
136 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
137 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 138 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af 139 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
ded9d4e2 140 echo "Dir::Bin::methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
147 export LC_ALL=C
148 msgdone "info"
149}
150
151configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT::Architecture \"$1\";" > $CONFFILE
154 shift
155 while [ -n "$1" ]; do
156 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
157 shift
158 done
159}
160
75954ae2 161setupsimplenativepackage() {
ce9864a8
DK
162 local NAME="$1"
163 local ARCH="$2"
164 local VERSION="$3"
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
b7899b00
DK
168 local SECTION="${7:-others}"
169 local DISTSECTION
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
171 DISTSECTION="main"
172 else
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
174 fi
ce9864a8
DK
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
177 cd ${BUILDDIR}
178 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
181
182 * Initial release
183
b7899b00
DK
184 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source: $NAME
186Section: $SECTION
ce9864a8
DK
187Priority: optional
188Maintainer: Joe Sixpack <joe@example.org>
189Build-Depends: debhelper (>= 7)
190Standards-Version: 3.9.1
191
875bcb36
DK
192Package: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture: all" >> debian/control
195 else
196 echo "Architecture: any" >> debian/control
197 fi
ce9864a8
DK
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
201 If you find such a package installed on your system,
202 YOU did something horribly wrong! They are autogenerated
203 und used only by testcases for APT and surf no other propose…" >> debian/control
204 else
205 echo "Description: $DESCRIPTION" >> debian/control
206 fi
b7899b00
DK
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
210 cd - > /dev/null
211}
212
213buildsimplenativepackage() {
214 local NAME="$1"
215 local ARCH="$2"
216 local VERSION="$3"
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
221 local DISTSECTION
222 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
223 DISTSECTION="main"
224 else
225 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
226 fi
5a635ee4 227 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 228
18331adf 229 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
230 mkdir -p $BUILDDIR/debian/source
231 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
232 echo "#!/bin/sh
233echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
234
235 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
236 echo "$NAME ($VERSION) $RELEASE; urgency=low
237
238 * Initial release
239
240 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
241 echo "Source: $NAME
242Section: $SECTION
243Priority: optional
244Maintainer: Joe Sixpack <joe@example.org>
245Standards-Version: 3.9.1
246
875bcb36
DK
247Package: $NAME" > ${BUILDDIR}/debian/control
248 if [ "$ARCH" = 'all' ]; then
249 echo "Architecture: all" >> ${BUILDDIR}/debian/control
250 else
251 echo "Architecture: any" >> ${BUILDDIR}/debian/control
252 fi
b761356f
DK
253 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
254 if [ -z "$DESCRIPTION" ]; then
255 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
256 If you find such a package installed on your system,
257 YOU did something horribly wrong! They are autogenerated
258 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
259 else
260 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
261 fi
262 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
263 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
264
265 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
266 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
267 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
875bcb36 268 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$ARCH)
b761356f
DK
269 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
270
5a635ee4
DK
271 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. > /dev/null
272 echo "pool/${NAME}_${VERSION}_${ARCH}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
b761356f 273 for SRC in $SRCS; do
5a635ee4 274 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 275 done
5a635ee4 276 rm -rf "${BUILDDIR}"
b761356f 277 msgdone "info"
75954ae2
DK
278}
279
280buildpackage() {
281 local BUILDDIR=$1
282 local RELEASE=$2
283 local SECTION=$3
284 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
285 cd $BUILDDIR
286 if [ "$ARCH" = "all" ]; then
287 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
288 fi
b7899b00
DK
289 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
290 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 291 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 292 cd - > /dev/null
b7899b00 293 for PKG in $PKGS; do
75954ae2 294 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
295 done
296 for SRC in $SRCS; do
75954ae2 297 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 298 done
cffea9af 299 msgdone "info"
ce9864a8
DK
300}
301
302buildaptarchive() {
ce9864a8
DK
303 if [ -d incoming ]; then
304 buildaptarchivefromincoming $*
305 else
306 buildaptarchivefromfiles $*
307 fi
308}
309
310createaptftparchiveconfig() {
311 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
312 if [ -z "$ARCHS" ]; then
313 # the pool is empty, so we will operate on faked packages - let us use the configured archs
314 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
315 fi
ce9864a8
DK
316 echo -n 'Dir {
317 ArchiveDir "' >> ftparchive.conf
318 echo -n $(readlink -f .) >> ftparchive.conf
319 echo -n '";
320 CacheDir "' >> ftparchive.conf
321 echo -n $(readlink -f ..) >> ftparchive.conf
322 echo -n '";
b7899b00
DK
323 FileListDir "' >> ftparchive.conf
324 echo -n $(readlink -f pool/) >> ftparchive.conf
325 echo -n '";
326};
327Default {
328 Packages::Compress ". gzip bzip2 lzma";
329 Sources::Compress ". gzip bzip2 lzma";
330 Contents::Compress ". gzip bzip2 lzma";
18331adf
DK
331 Translation::Compress ". gzip bzip2 lzma";
332 LongDescription "false";
ce9864a8
DK
333};
334TreeDefault {
335 Directory "pool/";
336 SrcDirectory "pool/";
337};
338APT {
339 FTPArchive {
340 Release {
341 Origin "joesixpack";
342 Label "apttestcases";
343 Suite "unstable";
344 Description "repository with dummy packages";
345 Architectures "' >> ftparchive.conf
346 echo -n "$ARCHS" >> ftparchive.conf
347 echo 'source";
348 };
349 };
350};' >> ftparchive.conf
b7899b00
DK
351 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
352 echo -n 'tree "dists/' >> ftparchive.conf
353 echo -n "$DIST" >> ftparchive.conf
354 echo -n '" {
ce9864a8
DK
355 Architectures "' >> ftparchive.conf
356 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
357 echo -n 'source";
358 FileList "' >> ftparchive.conf
359 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
360 echo -n '";
361 SourceFileList "' >> ftparchive.conf
362 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
363 echo -n '";
364 Sections "' >> ftparchive.conf
365 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
366 echo '";
ce9864a8 367};' >> ftparchive.conf
b7899b00 368 done
ce9864a8
DK
369}
370
371buildaptftparchivedirectorystructure() {
b7899b00
DK
372 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
373 for DIST in $DISTS; do
374 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
375 for SECTION in $SECTIONS; do
376 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
377 for ARCH in $ARCHS; do
378 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
379 done
380 mkdir -p dists/${DIST}/${SECTION}/source
381 mkdir -p dists/${DIST}/${SECTION}/i18n
382 done
ce9864a8 383 done
ce9864a8
DK
384}
385
9b78cda6
DK
386insertpackage() {
387 local RELEASE="$1"
388 local NAME="$2"
389 local ARCH="$3"
390 local VERSION="$4"
391 local DEPENDENCIES="$5"
392 local ARCHS="$ARCH"
393 if [ "$ARCHS" = "all" ]; then
394 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
395 fi
396 for BUILDARCH in $ARCHS; do
397 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
398 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
399 touch aptarchive/dists/${RELEASE}/main/source/Sources
400 local FILE="${PPATH}/Packages"
401 echo "Package: $NAME
402Priority: optional
403Section: other
2c085486 404Installed-Size: 42
9b78cda6
DK
405Maintainer: Joe Sixpack <joe@example.org>
406Architecture: $ARCH
2c085486
DK
407Version: $VERSION
408Filename: pool/main/${NAME}/${NAME}_${VERSION}_${ARCH}.deb" >> $FILE
9b78cda6
DK
409 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
410 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
411 If you find such a package installed on your system,
412 YOU did something horribly wrong! They are autogenerated
413 und used only by testcases for APT and surf no other propose…
414" >> $FILE
415 done
416}
417
ce9864a8 418buildaptarchivefromincoming() {
3cbbda3c 419 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
420 cd aptarchive
421 [ -e pool ] || ln -s ../incoming pool
422 [ -e ftparchive.conf ] || createaptftparchiveconfig
423 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 424 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 425 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
426 cd - > /dev/null
427 msgdone "info"
9b78cda6 428 generatereleasefiles
ce9864a8
DK
429}
430
431buildaptarchivefromfiles() {
3cbbda3c 432 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
433 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
434 msgninfo "\t${line} file… "
435 cat ${line} | gzip > ${line}.gz
436 cat ${line} | bzip2 > ${line}.bz2
437 cat ${line} | lzma > ${line}.lzma
8d876415 438 msgdone "info"
9b78cda6
DK
439 done
440 generatereleasefiles
441}
442
443generatereleasefiles() {
444 msgninfo "\tGenerate Release files… "
fe0f7911 445 local DATE="${1:-now}"
9b78cda6 446 if [ -e aptarchive/dists ]; then
18331adf
DK
447 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
448 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
449 done
9b78cda6 450 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 451 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
452 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
453 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
454 sed -i '/^Date: / a\
455NotAutomatic: yes' $dir/Release
456 fi
9b78cda6
DK
457 done
458 else
459 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 460 fi
fe0f7911
DK
461 if [ "$DATE" != "now" ]; then
462 for release in $(find ./aptarchive -name 'Release'); do
463 touch -d "$1" $release
464 done
8d876415 465 fi
b7899b00 466 msgdone "info"
8d876415
DK
467}
468
b7899b00
DK
469setupdistsaptarchive() {
470 local APTARCHIVE=$(readlink -f ./aptarchive)
471 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
472 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
473 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
474 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
475 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
476 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
477 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
478 msgdone "info"
479 done
480}
481
482setupflataptarchive() {
ce9864a8 483 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
484 if [ -f ${APTARCHIVE}/Packages ]; then
485 msgninfo "\tadd deb sources.list line… "
486 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
487 msgdone "info"
488 else
489 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
490 fi
491 if [ -f ${APTARCHIVE}/Sources ]; then
492 msgninfo "\tadd deb-src sources.list line… "
493 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
494 msgdone "info"
495 else
496 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
497 fi
b7899b00
DK
498}
499
500setupaptarchive() {
501 buildaptarchive
502 if [ -e aptarchive/dists ]; then
503 setupdistsaptarchive
504 else
505 setupflataptarchive
506 fi
f213b6ea 507 signreleasefiles
cd725954 508 msgninfo "\tSync APT's cache with the archive… "
8d876415 509 aptget update -qq
cd725954 510 msgdone "info"
8d876415
DK
511}
512
f213b6ea
DK
513signreleasefiles() {
514 local SIGNER="${1:-Joe Sixpack}"
515 msgninfo "\tSign archive with $SIGNER key… "
516 local SECKEYS=""
517 for KEY in $(find keys/ -name '*.sec'); do
518 SECKEYS="$SECKEYS --secret-keyring $KEY"
519 done
520 local PUBKEYS=""
521 for KEY in $(find keys/ -name '*.pub'); do
522 PUBKEYS="$PUBKEYS --keyring $KEY"
523 done
524 for RELEASE in $(find aptarchive/ -name Release); do
525 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 526 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
527 done
528 msgdone "info"
529}
530
531changetowebserver() {
532 if which weborf > /dev/null; then
533 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 534 addtrap "kill $!;"
f213b6ea
DK
535 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
536 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
537 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
538 done
539 return 0
540 fi
541 return 1
542}
543
544checkdiff() {
8d876415
DK
545 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
546 if [ -n "$DIFFTEXT" ]; then
547 echo
548 echo "$DIFFTEXT"
549 return 1
550 else
551 return 0
552 fi
553}
554
75954ae2
DK
555testfileequal() {
556 local FILE="$1"
557 shift
558 msgtest "Test for correctness of file" "$FILE"
559 if [ -z "$*" ]; then
f213b6ea 560 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 561 else
f213b6ea 562 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
563 fi
564}
565
8d876415
DK
566testequal() {
567 local COMPAREFILE=$(mktemp)
b720d0bd 568 addtrap "rm $COMPAREFILE;"
8d876415
DK
569 echo "$1" > $COMPAREFILE
570 shift
571 msgtest "Test for equality of" "$*"
f213b6ea 572 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
573}
574
685625bd
DK
575testequalor2() {
576 local COMPAREFILE1=$(mktemp)
577 local COMPAREFILE2=$(mktemp)
578 local COMPAREAGAINST=$(mktemp)
b720d0bd 579 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
580 echo "$1" > $COMPAREFILE1
581 echo "$2" > $COMPAREFILE2
582 shift 2
583 msgtest "Test for equality OR of" "$*"
584 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
585 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
586 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
587 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
588 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
589 msgfail )
590}
591
8d876415 592testshowvirtual() {
4bec02c2 593 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
594 local PACKAGE="$1"
595 shift
596 while [ -n "$1" ]; do
597 VIRTUAL="${VIRTUAL}
4bec02c2 598N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
599 PACKAGE="${PACKAGE} $1"
600 shift
601 done
602 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
603 VIRTUAL="${VIRTUAL}
4bec02c2 604N: No packages found"
8d876415 605 local COMPAREFILE=$(mktemp)
b720d0bd 606 addtrap "rm $COMPAREFILE;"
8d876415
DK
607 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
608 eval `apt-config shell ARCH APT::Architecture`
609 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 610 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
611}
612
613testnopackage() {
614 msgtest "Test for non-existent packages" "apt-cache show $*"
615 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
616 if [ -n "$SHOWPKG" ]; then
617 echo
618 echo "$SHOWPKG"
619 msgfail
620 return 1
621 fi
622 msgpass
623}
01a6e24c
DK
624
625testdpkginstalled() {
626 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
627 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
628 if [ "$PKGS" != 0 ]; then
629 echo $PKGS
630 dpkg -l $* | grep '^[a-z]'
631 msgfail
632 return 1
633 fi
634 msgpass
635}
636
637testdpkgnoninstalled() {
638 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
639 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
640 if [ "$PKGS" != 0 ]; then
641 echo
642 dpkg -l $* | grep '^[a-z]'
643 msgfail
644 return 1
645 fi
646 msgpass
647}